package logic

import (
	"GtDataStore/app/model"
	"context"
	"github.com/jinzhu/copier"

	"GtDataStore/app/cmd/organization/internal/svc"
	"GtDataStore/app/cmd/organization/pb"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetWorkingRoByCodeLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetWorkingRoByCodeLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetWorkingRoByCodeLogic {
	return &GetWorkingRoByCodeLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *GetWorkingRoByCodeLogic) GetWorkingRoByCode(in *pb.DcWorkingReq) (*pb.WorkingRo, error) {
	//基础条件
	workingRoInfo, err := l.svcCtx.WorkingRo.FindOneByCode(l.ctx, in.ProjectId, in.DeviceCode)
	if err != nil && err != model.ErrNotFound {
		logx.Errorf("not found workingUf data")
		return nil, err
	}

	resp := &pb.WorkingRo{}
	_ = copier.Copy(resp, workingRoInfo)
	resp.CTime = workingRoInfo.CTime.Format("2006-01-02 15:04:05")

	return resp, nil
}
