// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcWorkingValveFieldNames          = builder.RawFieldNames(&DcWorkingValve{})
	dcWorkingValveRows                = strings.Join(dcWorkingValveFieldNames, ",")
	dcWorkingValveRowsExpectAutoSet   = strings.Join(stringx.Remove(dcWorkingValveFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcWorkingValveRowsWithPlaceHolder = strings.Join(stringx.Remove(dcWorkingValveFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcWorkingValveModel interface {
		MultiInsert(ctx context.Context, datas []DcWorkingValve) (int64, error)
		Insert(ctx context.Context, data *DcWorkingValve) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcWorkingValve, error)
		Update(ctx context.Context, data *DcWorkingValve) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcWorkingValveModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcWorkingValve struct {
		Id          int64     `db:"id"`
		ProjectId   int64     `db:"project_id"`
		DeviceCode  string    `db:"device_code"`
		Adjust      int64     `db:"adjust"`       // 是否为调节阀门 0： 否 1： 是
		Opening     float64   `db:"opening"`      // 当前阀门的开度
		Closed      int64     `db:"closed"`       // 关到位 全关  0: 否 1： 是
		Opened      int64     `db:"opened"`       // 开到位 开到 设置的开度 0: 否 1： 是
		FaultStatus int64     `db:"fault_status"` // 是否故障 0: 否 1： 是
		CTime       time.Time `db:"c_time"`
	}
)

func newDcWorkingValveModel(conn sqlx.SqlConn) *defaultDcWorkingValveModel {
	return &defaultDcWorkingValveModel{
		conn:  conn,
		table: "`dc_working_valve`",
	}
}

func (m *defaultDcWorkingValveModel) withSession(session sqlx.Session) *defaultDcWorkingValveModel {
	return &defaultDcWorkingValveModel{
		conn:  sqlx.NewSqlConnFromSession(session),
		table: "`dc_working_valve`",
	}
}

func (m *defaultDcWorkingValveModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcWorkingValveModel) FindOne(ctx context.Context, id int64) (*DcWorkingValve, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcWorkingValveRows, m.table)
	var resp DcWorkingValve
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcWorkingValveModel) MultiInsert(ctx context.Context, datas []DcWorkingValve) (int64, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?)", m.table, dcWorkingValveRowsExpectAutoSet)

	if bulk, err := sqlx.NewBulkInserter(m.conn, query);err == nil {
		for _, data := range datas {
			if err = bulk.Insert(data.ProjectId, data.DeviceCode, data.Adjust, data.Opening, data.Closed, data.Opened, data.FaultStatus, data.CTime);err != nil {
				return 0, err
			}
		}

		bulk.Flush()
		return int64(len(datas)), nil
	} else {
		return 0, err
	}
}

func (m *defaultDcWorkingValveModel) Insert(ctx context.Context, data *DcWorkingValve) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?)", m.table, dcWorkingValveRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.Adjust, data.Opening, data.Closed, data.Opened, data.FaultStatus, data.CTime)
	return ret, err
}

func (m *defaultDcWorkingValveModel) Update(ctx context.Context, data *DcWorkingValve) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcWorkingValveRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.Adjust, data.Opening, data.Closed, data.Opened, data.FaultStatus, data.CTime, data.Id)
	return err
}

func (m *defaultDcWorkingValveModel) tableName() string {
	return m.table
}
